/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2014 ILS Technology, LLC
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef _TR50_ERROR_H_
#define _TR50_ERROR_H_
#define ERR_TR50_FILE_PUT_HTTP			    -20008
#define ERR_TR50_FILE_WRITE_FAILED		    -7058
#define ERR_TR50_FILE_GET_HTTP			    -20009
#define ERR_TR50_PARMS						-18001
#define ERR_TR50_MALLOC						-18002
#define ERR_TR50_NOT_CONNECTED				-18003
#define ERR_TR50_CMD_UNKNOWN				-18004
#define ERR_TR50_REQ_TIMEOUT				-18005
#define ERR_TR50_CODE_MISSING				-18006
#define ERR_TR50_JSON_INVALID				-18007
#define ERR_TR50_BADHANDLE					-18008
#define ERR_TR50_TIMEOUT					-18009
#define ERR_TR50_ASYNC_CLIENT_NOT_CONNECTED	-18010
#define ERR_TR50_MQTT_RECV_DECODE_HDR_LEN	-18011
#define ERR_TR50_TCP_TIMEOUT				-18012
#define ERR_TR50_ALREADY_STARTED			-18013
#define ERR_TR50_ALREADY_STOPPED			-18014
#define ERR_TR50_NOPORT						-18015
#define ERR_TCP_PROXY_TYPE_UNKNOWN			-18016
#define ERR_TR50_TCP_SSL_NOTINIT			-18017
#define ERR_TR50_MODEM_EXEC_FAILED			-18018
#define ERR_TR50_COMPRESS_DEFLATE			-18019
#define ERR_TR50_COMPRESS_INFLATE			-18020
#define ERR_TR50_ASYNC_CLIENT_SAME_THREAD	-18021
#define ERR_TR50_STOPPING					-18022
#define ERR_TR50_CONNECTED					-18023
#define ERR_TR50_STOPPED					-18024
#define ERR_TR50_LOCAL_FILE_NOTFOUND		-18025
#define ERR_TR50_HTTP_PROXY_FAILED			-18026
#define ERR_TR50_COMPRESS_NOT_SUPPORTED		-18027
#define ERR_TR50_REPLY_INVALID				-18028
#define ERR_TR50_CMD_ID_NOT_FOUND			-18029
#define ERR_TR50_METHOD_UNKNOWN				-18030
#define ERR_TR50_MAILBOX_SUSPENDED			-18031
#define ERR_TR50_AGGREGATION_DISABLED		-18032 
#define ERR_CMD_NOT_BATCHABLE				-18033 
#define ERR_TR50_AGGREGATION_SIZE_EXCEEDS   -18034

#define ERR_TR50_MAILBOX_CHECK_IN_PROGRESS  -18038
#define ERR_TR50_REQ_TIMEOUT_PING_FAILURE	-18039

#define ERR_TR50_AT_STORAGE_FULL			-18101
#define ERR_TR50_AT_SEND_MODE_UNKNOWN		-18102
#define ERR_TR50_AT_STORAGE_NOTFOUND		-18103
#define ERR_TR50_AT_STORAGE_MODE_MISMATCH	-18104
#define ERR_TR50_STORAGE_NOPARMS			-18105
#define ERR_TR50_AT_ATTACH_FAIL				-18106
#define ERR_TR50_AT_DETACH_FAIL				-18106
#define ERR_TR50_AT_EXEC_FAIL				-18107
#define ERR_TR50_AT_UNEVEN_PARAMS			-18108
#define ERR_TR50_AT_EXEC_IN_PROGRESS		-18109

//Added
#define ERR_TR50_OS							-18200

#define ERR_TR50_SOCK_SOCKET_FAILED         -18300
#define ERR_TR50_SETSOCKOPT_FAILED			-18301
#define ERR_TR50_SOCK_FNCTL_FAILED			-18302
#define ERR_TR50_SOCK_IOCTL_FAILED			-18303
#define ERR_TR50_SOCK_CONNECT_FAILED        -18304
#define ERR_TR50_SOCK_SELECT_FAILED			-18305
#define ERR_TR50_SOCK_OTHER					-18306
#define ERR_TR50_PROXY_CONN_FAILED			-18307
#define ERR_TR50_PROXY_PROTO_BAD			-18308
#define ERR_TR50_SSL_BADCTX					-18309
#define	ERR_TR50_SSL_CONNECT				-18310
#define ERR_TR50_SOCK_PROXY_AUTH_REJECTED   -18311
#define ERR_TR50_SOCK_PROXY_OTHER			-18312
#define ERR_TR50_SOCK_PROXY_AUTH_UNSUP		-18313
#define ERR_TR50_SOCK_TIMEOUT				ERR_TR50_TCP_TIMEOUT
#define ERR_TR50_SOCK_HOSTNOTFOUND			-18315
#define ERR_TR50_SSL_NOTINIT				ERR_TR50_TCP_SSL_NOTINIT
#define ERR_TR50_SOCK_FUNC_NOT_SUPPORTED	-18317
#define ERR_TR50_SOCK_IS_ZERO				-18318
#define ERR_TR50_SOCK_GETSOCKOPT_FAILED		-18319
#define ERR_TR50_SOCK_SETSOCKOPT_FAILED		-18320
#define ERR_TR50_SOCK_SEND_FAILED			-18321
#define ERR_TR50_SOCK_BAD_TIMEOUT			ERR_TR50_TCP_TIMEOUT
#define ERR_TR50_SOCK_RECV_FAILED			-18323
#define ERR_TR50_SOCK_SHUTDOWN				-18324
#define ERR_TR50_SSL_GENERIC				-18325
#define ERR_TR50_SSL_CTX					-18326

/* connack errors */
#define ERR_MQTT_MSG_CONNACK_TYPE				-18201
#define ERR_MQTT_MSG_CONNACK_LENGTH				-18202
#define ERR_MQTT_MSG_CONNACK_UNKNOWN_RETURN		-18203
#define ERR_MQTT_MSG_CONNACK_VERSION			-18204
#define ERR_MQTT_MSG_CONNACK_ID					-18205
#define ERR_MQTT_MSG_CONNACK_BROKER				-18206
#define ERR_MQTT_MSG_CONNACK_LOGIN				-18207
#define ERR_MQTT_MSG_CONNACK_NOT_AUTHORIZED		-18208

/* puback errors */
#define ERR_MQTT_MSG_PUBACK_LENGTH				-18211
#define ERR_MQTT_MSG_PUBACK_TYPE				-18212

/* publish errors */
#define ERR_MQTT_MSG_PUBLISH_LENGTH				-18213
#define ERR_MQTT_MSG_PUBLISH_TYPE				-18214
#define ERR_MQTT_MSG_PUBLISH_DECODE_HDR_LEN		-18215
#define ERR_MQTT_MSG_PUBLISH_PAYLOAD_LEN_NEGATIVE	-18216

/* suback errors */
#define ERR_MQTT_MSG_SUBACK_LENGTH				-18216
#define ERR_MQTT_MSG_SUBACK_TYPE				-18217
#define ERR_MQTT_MSG_SUBACK_QOS_FAILURE			-18218

/* unsuback errors*/
#define ERR_MQTT_MSG_UNSUBACK_LENGTH			-18219
#define ERR_MQTT_MSG_UNSUBACK_TYPE				-18220

#define ERR_MQTT_QOS_FAILURE					-18221
#define ERR_MQTT_QOS_STOPPING					-18222
#define ERR_MQTT_QOS_FULL						-18223
#define ERR_MQTT_QOS_NOTFOUND					-18224
#define ERR_MQTT_QOS_EXPIRED					-18225

#define ERR_MQTT_PING_EXPIRED					-18231
#define ERR_MQTT_PING_IN_PROGRESS				-18232

/* tr50 errors*/
#define	ERR_TR50_API_INVALID_PARAM				-20001
#define ERR_TR50_DATA_CONVERSION				-20002
#define ERR_TR50_METHOD_NO_METADATA				-20003
#define ERR_TR50_METHOD_EVT_EXISTS				-20004
#define ERR_TR50_METHOD_NO_HANDLED				-20005
#define ERR_TR50_ACT_CONFIG_NO_INPUT			-20006
#define ERR_TR50_REG_HWID_NOT_FOUND				-20007
#define ERR_TR50_FILE_PUT_HTTP					-20008
#define ERR_TR50_FILE_GET_HTTP					-20009
#define ERR_TR50_DIAGNOSTIC_FILE_PARAM			-20010
#define ERR_TR50_ACT_REPLY_FAILED				-20011
#define ERR_TR50_REG_GUID_NOT_FOUND				-20012
#define ERR_TR50_MQTT_PUBLISH_INVALID_TOPIC		-20013
#define ERR_TR50_MQTT_SUBSCRIBE_INVALID_TOPIC	-20014
#define ERR_TR50_MQTT_PUBLISH_QOS_INVALID		-20015
#define ERR_TR50_CONN_NOT_FOUND					-20016
#define ERR_TR50_CONN_INVALID_NAME				-20017
#define ERR_TR50_CONN_EXISTS					-20018
#define ERR_TR50_CONN_DEL_STARTED               -20019
#define ERR_TR50_CONN_DEL_DEFAULT				-20020
#define ERR_TR50_SUP_IN_PROGRESS				-20021
#define ERR_TR50_SUP_FILE_RETRY_FAILED			-20022
#define ERR_TR50_SUP_LOCAL_FILE_MISSING			-20023
#define ERR_TR50_SUP_STATUS_FILE_MISSING		-20024
#define ERR_TR50_TUNNEL_EXIST					-20031
#define ERR_TR50_TUNNEL_WB_NOT_ALLOW			-20032
#define ERR_TR50_TUNNEL_NOT_ALLOW				-20033
#define ERR_TR50_TUNNEL_EVT_NOT_ALLOW			-20034
#endif //_TR50_ERROR_H_
